package cn.com.taiji.entity;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

/**
 * @author chenfangchao
 * @title: FusionBaseEntity
 * @projectName es-track-analysis
 * @description: TODO
 * @date 2023/2/6 8:03 PM
 */
@Data
public class FusionBaseEntity implements Serializable {
    private static final long serialVersionUID = 9164079715828741429L;

    /**
     * 融合主键
     **/
    private String mergeId;

    /**
     * 融合时间
     **/
    private String mergeTime;

    /**
     * 融合目标唯一标识
     **/
    private String mergeTarget;

    /**
     * 国籍
     **/
    private String targetNationality;

    /**
     * 船舶类型
     **/
    private String targetShipType;

    /**
     * 融合目标名称（中文）
     **/
    private String targetName;

    /**
     * 融合目标名称（英文）
     **/
    private String targetNameEn;

    /**
     * 目标经度
     **/
    private Double targetLongitude;

    /**
     * 目标纬度
     **/
    private Double targetLatitude;

    /**
     * 目标航向
     **/
    private Double targetCourse;

    /**
     * 目标速度
     **/
    private Double targetSpeed;

    /**
     * 目标艏向
     **/
    private Double targetHeading;

    /**
     * 当前转向率
     **/
    private Double targetRot;

    /**
     * 当前最大吃水
     **/
    private Double targetDraught;

    /**
     * 目标状态
     **/
    private Integer targetState;

    /**
     * 目标分类
     **/
    private Integer targetType;

    /**
     * 目标长度
     */
    private String targetLength;

    /**
     * 目标（航迹）可信度
     **/
    private Integer targetTypeReliability;

    /**
     * 航迹状态
     **/
    private Integer targetTrackState;

    /**
     * 目标持续时长
     **/
    private Long targetTrackTime;

    /**
     * 融合关联子源信息（最新）
     **/
    private List<FusionNewShipJsonDTO> targetSource;


    private String  targetSourceJson;


    /**
     * 在港状态
     **/
    private Integer portState;

    /**
     * 港口id
     **/
    private String portId;

    /**
     * 加油状态
     **/
    private Integer refueledState;

    /**
     * 加油区域id
     **/
    private String refueledAreaId;

    /**
     * 加冰/加水状态
     **/
    private Integer supplyIceWaterState;

    /**
     * 加冰/加水区域id
     **/
    private String supplyIceWaterAreaId;

    /**
     * 在航状态
     **/
    private Integer motionState;


    /**
     * 海兰信光电跟踪ID
     */
    private String targetMonitorId;

    private String monitorId;

    /**
     * 地图筛选专用字段
     */
    private Integer gisNationality;


    /**
     * 地图筛选专用字段
     */
    private Integer gisShipType;


    /**
     * 轨迹设备编码
     */
    private String  trackDeviceNo;

    /**
     * 融合类型
     */
    private String mergeType;


    private String sClass;


    /** 是否被关注 0未关注 1已关注**/
    private Integer focus = 0;

    /** 是否为重点 0否 1是 **/
    private Integer fokey = 0;

    /** 关注颜色 **/
    private String focusColor = "";

    /** 用户id **/
    private String focusUserId = "";

    /** 位置 **/
    private String location;
}

