package cn.com.taiji.controller;

import cn.com.taiji.domain.FusionQuery;
import cn.com.taiji.service.FusionAnalysisService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.text.ParseException;

/**
 * @author xhl
 * @date 2023/2/6
 */
@RequestMapping("/es/fusion/analysis")
@RestController
public class FusionAnalysisController {

    @Resource
    private FusionAnalysisService fusionAnalysisService;

    /**
     * 轨迹融合-航速航向异常波动-识别融合数据率波动问题
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("excel/one")
    public void fusionAnalysisExcelOne(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.fusionAnalysisExcelOne(query,response);
    }

    /**
     * 虚假外推数据-虚假推送问题
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("excel/two")
    public void fusionAnalysisExcelTwo(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.fusionAnalysisExcelTwo(query,response);
    }

    /**
     * 遗漏融合-天奥轨迹数据遗漏
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("/tianao/excel")
    public void tianAoLeaveOutExcel(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.tianAoLeaveOutExcel(query,response);
    }

    /**
     * 遗漏融合-北斗轨迹数据遗漏
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("/beidou/excel")
    public void beiDouLeaveOutExcel(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.beiDouLeaveOutExcel(query,response);
    }

    /**
     * 遗漏融合-海兰信1级融合轨迹数据遗漏
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("/hlxyjrh/excel")
    public void hlxyjrhLeaveOutExcel(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.hlxyjrhLeaveOutExcel(query,response);
    }

    /**
     * 错误融合-天奥静态数据与动态轨迹融合
     * @param query
     * @param response
     * @throws IOException
     * @throws ParseException
     */
    @PostMapping("/tianao/static/excel")
    public void tianaoStaticOrDynamicLeaveOutExcel(@RequestBody FusionQuery query, HttpServletResponse response) throws IOException, ParseException {
        fusionAnalysisService.tianaoStaticOrDynamicLeaveOutExcel(query,response);
    }
}
