package cn.com.taiji.entity;


import lombok.Data;
import lombok.ToString;

/**
 * @author chenfangchao
 * @title: HxlOneLevelShipTrackDTO
 * @projectName ax-geomesa-redis
 * @description: TODO
 * @date 2022/11/7 5:29 PM
 */
@Data
@ToString
public class HlxOneLevelShipTrackDTO {

    /** 一级融合输出批次号 **/
    private String targetId;

    /** 雷达主站点编号，非雷达融合目标取0 **/
    private String radarId;

    /** true/false，目标是否处于预测态 **/
    private String predicted;

    /** 航速，节 **/
    private Float speed;

    /** 航向，度 **/
    private Float course;

    /** 艏向，度 **/
    private Float heading;

    /** 经度，度 **/
    private Float longitude;

    /** 纬度，度 **/
    private Float latitude;

    /** 船长 **/
    private Double length;

    /** 非AIS融合取0 **/
    private String mmsi;

    /** 0:非AIS融合，1:class A 2:class B 3:AID **/
    private Long shipClass;

    /** 0:非AIS融合，非0：AIS船型编号 **/
    private Long shipType;

    /** 船名 **/
    private String vesselName;

    /** 融合时间，utc毫秒 **/
    private String time;


    /**
     * 太极应用层计算
     */
    private String gisShipType;

    private String gisNationality;

    /**
     * 位置
     */
    private String location;
}
